package
{
	import flash.display.BitmapData;
	import flash.ui.Mouse;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	import flash.geom.Rectangle;
	
	public class GameState extends FlxState
	{
		[Embed(source = "data/brush.png")] public static var ImgBrush:Class;
		[Embed(source = "data/brush2.png")] public static var ImgBrush2:Class;
		[Embed(source = "data/brush3.png")] public static var ImgBrush3:Class;
		[Embed(source = "data/delbrush.png")] public static var DelBrush:Class;		
		
		public var group:FlxGroup;
		
		public function GameState()
		{
			Mouse.show();
		}		
		
		public var oldpos:FlxPoint;
		public var oldVel:FlxPoint;
		
		public function onClick1():void
		{
			mode=1;
			b1.on=true;
			b2.on=false;
			b3.on=false;
			b4.on=false;
		}
		
		public function onClick2():void
		{
			mode=2;
			b1.on=false;
			b2.on=true;
			b3.on=false;
			b4.on=false;
		}
		
		public function onClick3():void
		{
			mode=3;
			b1.on=false;
			b2.on=false;
			b3.on=true;
			b4.on=false;
		}
		
		public function onClick4():void
		{
			mode=4;			
			b1.on=false;
			b2.on=false;
			b3.on=false;
			b4.on=true;
		}
		
		public var b1:FlxButton;
		public var b2:FlxButton;
		public var b3:FlxButton;
		public var b4:FlxButton;
		override public function create():void
		{

			
			oldpos = new FlxPoint(FlxG.mouse.x,FlxG.mouse.y);
			oldVel = new FlxPoint(0,0);
			bgColor=0xff000000;
			group = new FlxGroup();
			this.add(group);
			
			
			
			
			
			var s:FlxSprite;
			var t:FlxSprite;
			var u:FlxSprite;
			var lbl:FlxText;
			
			b1 = new FlxButton(0,12*0,onClick1);
			s = new FlxSprite(0,0);
			s.solid=false;
			s.createGraphic(11,11,0xffffffff);
			
			t = new FlxSprite(0,0);
			t.solid=false;
			t.createGraphic(11,11,0xff0000ff);
			b1.loadGraphic(s,t);
			u = new FlxSprite(3.5,3.5,ImgBrush);
			u.solid=false;
			u.color=0xff888888;
			b1.add(u);
			lbl = new FlxText(-2,-2,11,"1");
			lbl.size=6;
			lbl.color=0xffffff00;
			b1.add(lbl);
			this.add(b1);
			
			
			b2 = new FlxButton(0,12*1,onClick2);
			s = new FlxSprite(0,0);
			s.solid=false;
			s.createGraphic(11,11,0xffffffff);
			
			t = new FlxSprite(0,0);
			t.solid=false;
			t.createGraphic(11,11,0xff0000ff);
			b2.loadGraphic(s,t);
			u = new FlxSprite(2,2,ImgBrush2);
			u.solid=false;
			u.color=0xff888888;
			b2.add(u);
			lbl = new FlxText(-2,-2,11,"2");
			lbl.size=6;
			lbl.color=0xffffff00;
			b2.add(lbl);
			this.add(b2);
			
			
			b3 = new FlxButton(0,12*2,onClick3);
			s = new FlxSprite(0,0);
			s.solid=false;
			s.createGraphic(11,11,0xffffffff);
			
			t = new FlxSprite(0,0);
			t.solid=false;
			t.createGraphic(11,11,0xff0000ff);
			b3.loadGraphic(s,t);
			u = new FlxSprite(1,1,ImgBrush3);
			u.solid=false;
			u.color=0xff888888;
			b3.add(u);
			lbl = new FlxText(-2,-2,11,"3");
			lbl.size=6;
			lbl.color=0xffffff00;
			b3.add(lbl);
			this.add(b3);
			
			oldpos = new FlxPoint(FlxG.mouse.x,FlxG.mouse.y);
			oldVel = new FlxPoint(0,0);
			bgColor=0xff000000;
			group = new FlxGroup();
			this.add(group);
			
			
			b4 = new FlxButton(0,12*3,onClick4);
			s = new FlxSprite(0,0);
			s.solid=false;
			s.createGraphic(11,11,0xffffffff);
			
			t = new FlxSprite(0,0);
			t.solid=false;
			t.createGraphic(11,11,0xff0000ff);
			b4.loadGraphic(s,t);
			u = new FlxSprite(1,1,GameState.DelBrush);
			u.solid=false;
			u.color=0xff888888;
			b4.add(u);
			lbl = new FlxText(-2,-2,11,"4");
			lbl.size=6;
			lbl.color=0xffffff00;
			b4.add(lbl);
			this.add(b4);
			
			
			
			mode=2;
			b2.on=true;
			/*
			for (var i:int=0;i<320;i+=20)
			{				
				for (var j:int=0;j<240;j+=20)
				{
					var n:int = Math.random()*3;
					n++;
					var s:FlxSprite;
					switch(n)
					{
						case 1:
							s =  new FlxSprite(i,j,ImgBrush);
							break;
						case 2:
							s =  new FlxSprite(i,j,ImgBrush2);
							break;
						case 3:
							s =  new FlxSprite(i,j,ImgBrush3);
							break;
					}				
					group.add(s);
				}				
			}*/
		}
	
		public var mode:int;
		public var lastCreated:Number;
		override public function update():void
		{
			lastCreated+=FlxG.elapsed;
			for (var i:int=group.members.length-1; i>=0;i--)
			{
				var m:FlxSprite = group.members[i];
				if (m.x<-4 || m.x>320 || m.y<-4 || m.y>240)
				{
					group.members.splice(i,1);
				}
			}
			var d:Number = 0.1;
			oldVel.x = (oldVel.x*(1-d)) + (FlxG.mouse.x-oldpos.x)*d/FlxG.elapsed;
			oldVel.y = (oldVel.y*(1-d)) + (FlxG.mouse.y-oldpos.y)*d/FlxG.elapsed;
			
			if (FlxG.keys.justPressed("R"))
			{
				for (i=0;i<group.members.length;i++)
				{
					group.members[i].kill();
				}
				group.members=[];
			}
			if (FlxG.keys.justPressed("ONE"))
			{
				onClick1();
			}
			
			if (FlxG.keys.justPressed("TWO"))
			{
				onClick2();
			}	
			
			if (FlxG.keys.justPressed("THREE"))
			{
				onClick3();
			}
			if (FlxG.keys.justPressed("FOUR"))
			{
				onClick4();
			}
			if (FlxG.mouse.pressed() && FlxG.mouse.x>9)
			{				
				if (mode<4)
				{
					if (lastCreated>0.05||FlxG.mouse.justPressed())
					{
						
						var p:FlxSprite;
						switch(mode)
						{
							case 1:
								p =  new FlxSprite(FlxG.mouse.x-2,FlxG.mouse.y-2,ImgBrush);
								break;
							case 2:
								p =  new FlxSprite(FlxG.mouse.x-2,FlxG.mouse.y-2,ImgBrush2);
								break;
							case 3:
								p =  new FlxSprite(FlxG.mouse.x-2,FlxG.mouse.y-2,ImgBrush3);
								break;
						}
		
						p.velocity.x=oldVel.x/4;
						p.velocity.y=oldVel.y/4;
						var r:int = Math.random()*256;
						var g:int = Math.random()*256;
						var b:int = Math.random()*256;
						p.color= r*256*256 +  g*256 + b;
						p.maxVelocity = new FlxPoint(20,20);
						
						group.add(p);
						lastCreated=0;
					}
				}
				else if (mode==4)
				{
					for (i=group.members.length-1;i>=0;i--)
					{
						var s:FlxSprite = group.members[i];
						var dx:Number = FlxG.mouse.x-(s.x+s.width/2);
						var dy:Number = FlxG.mouse.y-(s.y+s.height/2);
						if (dx*dx+dy*dy<90)
						{
							s.kill();
							group.members.splice(i,1);
						}
						
					}
				}
			}
			collide();
			oldpos.x=FlxG.mouse.x;
			oldpos.y=FlxG.mouse.y;
			super.update();
		}
	}
}